#include "analisis_grano.h"

DWORD WINAPI hilo_analisis_granos( void* lpParam )
{
    ///Variables del programa

    RNG rng(12345);
    int i=0,umbral_bin=120,ancho,largo,num_fotos1=0,num_fotos2=0,ancho_granos=0,largo_granos=0;
    int num_granos_partidos=0,num_granos_tara=0,num_granos_buenos=0;
    float num_pixel_negro=0,area_elipse;
    int vector_anchos[num_granos], vector_largos[num_granos];
    int blue=0,red=0,green=0,pixel_bueno=0;
    float R,G,B,L,a,b,L_total=0,a_total=0,b_total=0;
    char key,key_pulsada=0;
    char num_granos_c[5],num_granos_buenos_c[5],num_granos_partidos_c[5],num_granos_tara_c[5],ancho_c[5],largo_c[5],L_total_c[5],a_total_c[5],b_total_c[5];
    FILE *fichero;
    DATOS *valores=(DATOS*)lpParam;

    char szBuffer_arduino[BUFFER_SIZE];
    char szBuffer_analisis[BUFFER_SIZE];
    DWORD cbBytes;

    ///Desarrollo del programa

    /* Creamos pipe para comunicacion IPC con proceso control de Arduino*/
    HANDLE hPipe_arduino;

    //Conexion al pipe servidor usando CreateFile()
    hPipe_arduino = CreateFile(
                        g_szPipeNameArduino,   // Nombre del pipe
                        GENERIC_READ |  // Acceso de lectura y escitura
                        GENERIC_WRITE,
                        0,              // Sin compartir
                        NULL,           // Atributos de seguridad por defecto
                        OPEN_EXISTING,  // Abre un pipe ya existente
                        0,              // Atributos por defecto
                        NULL);          // Sin fichero de template

    if (INVALID_HANDLE_VALUE == hPipe_arduino)
    {
        printf("\nError occurred while connecting"
               " to the server Arduino: %ld\n", GetLastError());
        //One might want to check whether the server pipe is busy
        //This sample will error out if the server pipe is busy
        //Read on ERROR_PIPE_BUSY and WaitNamedPipe() for that
        //return 1;  //Error
    }
    else
    {
        printf("\nCreateFileArduino() was successful.\n");
    }

    /* Nos conectamos al pipe creado en el proceso principal*/
    HANDLE hPipe_analisis;
    hPipe_analisis = CreateFile(
                         g_szPipeNameAnalisis,   // pipe name
                         GENERIC_READ |  // read and write access
                         GENERIC_WRITE,
                         0,              // no sharing
                         NULL,           // default security attributes
                         OPEN_EXISTING,  // opens existing pipe
                         0,              // default attributes
                         NULL);          // no template file

    if (INVALID_HANDLE_VALUE == hPipe_analisis)
    {
        printf("\nError occurred while connecting"
               " to the server Analisis: %ld\n", GetLastError());
        //One might want to check whether the server pipe is busy
        //This sample will error out if the server pipe is busy
        //Read on ERROR_PIPE_BUSY and WaitNamedPipe() for that
        //return 1;  //Error
    }
    else
    {
        printf("\nCreateFileAnalisis() was successful.\n");
    }

    CvCapture* captura = cvCaptureFromCAM(1);  ///Captura del video de la camara

    while(key!=27)///El programa se mantiene en ejecucuion hasta que se pulse la tecla "esq"
    {
        IplImage* frame = cvQueryFrame(captura);
        key = cvWaitKey(10);

        ///Tomar imagen
        if(key=='f' || key=='F'||key_pulsada=='f')
        {
            if (num_fotos1==0)
            {
                num_fotos1++;
            }
            if(num_fotos2==0)
            {
                num_fotos2++;
            }
            num_pixel_negro=0;
            area_elipse=0;
            blue=red=green=0;
            R=G=B=0;
            pixel_bueno=0;

            cvSaveImage("frame.png",frame);
            Mat I=imread("frame.png");
            Mat gris,binaria,imgRoi,contorno,blanco,binaria2;
            cvtColor(I,gris,CV_BGR2GRAY);
            Canny(gris,contorno,40,120);
            threshold(gris,binaria2,umbral_bin,255,THRESH_BINARY_INV );
            blanco=binaria2 | contorno;
            blanco=~blanco;
            imgRoi = binaria2(cv::Rect(440,250,400,400)); //ROI de la imagen binaria
			Mat imgRoi2 = blanco(cv::Rect(440,250,400,400)); //ROI de la imagen binaria+contorno
			Mat ROI=I(cv::Rect(440,250,400,400)); //ROI de la imagen original en color



            vector<vector<Point> > contours;
            vector<Vec4i> hierarchy;

            /// Buscar contornos a partir de la imagen binaria
            findContours( imgRoi, contours, hierarchy, CV_RETR_TREE, CV_CHAIN_APPROX_SIMPLE, Point(0, 0) );

            /// Buscar el rectangulo de menor area que se ajuste al objeto
            RotatedRect box = minAreaRect(contours[0]);
            ancho=box.size.width;
            largo=box.size.height;
            int aux;
            if(ancho>largo)
            {
                aux=largo;
                largo=ancho;
                ancho=aux;
            }

            ///Ajustar el grano a una elipse
            area_elipse=3.1416*(ancho/2)*(largo/2);
            printf("\n El area de la elipse aproximada es %f\n",area_elipse);

            /// Dibujar contorno y rectangulo de menor area
            Mat drawing = Mat::zeros( imgRoi.size(), CV_8UC3 );
            for( int i = 0; i< contours.size(); i++ )
            {
                Scalar color = Scalar( rng.uniform(0, 255), rng.uniform(0,255), rng.uniform(0,255) );
                drawContours( drawing, contours, i, color, 1, 8, vector<Vec4i>(), 0, Point() );
                Point2f rect_points[4];
                box.points( rect_points );
                for( int j = 0; j < 4; j++ )
                {
                    line( drawing, rect_points[j], rect_points[(j+1)%4], color, 1, 8 );
                }
            }
            Mat element = getStructuringElement( MORPH_RECT, Size(1,1),Point( 0, 0 ) );
            morphologyEx( drawing, drawing, MORPH_OPEN, element );

            ///Contar numero de pixeles negros en la imagen

            for(int f=0; f<300; f++)
            {
                for(int c=0; c<300; c++)
                {
                    if(imgRoi2.at<uchar>(f,c)==0)
                        num_pixel_negro++;
                }
            }
            printf("\n El numero de pixeles negros es %f\n",num_pixel_negro);

            ///Recorremos la imagen pixel por pixel y se analiza su valor, los pixeles que pertenecen al fondo no se tienen en cuenta
            for(int i=0; i<300; i++)
            {
                for(int j=0; j<300; j++)
                {
                    Vec3b intensity = ROI.at<Vec3b>(i,j);
                    red = intensity.val[2];
                    green = intensity.val[1];
                    blue = intensity.val[0];

                    if((blue<135)&(green<124)&(red<135))
                    {
                        pixel_bueno++;
                        R=R+red;
                        G=G+green;
                        B=B+blue;
                    }
                }
            }

            R=R/pixel_bueno;
            G=G/pixel_bueno;
            B=B/pixel_bueno;

            printf("\n R=%f G=%f B=%f \n", R,G,B);

            convertir_rgb_lab(R,G,B,&L,&a,&b);

            imwrite("contorno.png",drawing);
            imwrite("byn.png",imgRoi2);
        }

        ///Una vez se tienen las dos fotos analizar resultados
        if((num_fotos1+num_fotos2)==2)
        {
            float promedio;

            ///Comprobar si el grano esta partido
            if(num_pixel_negro>area_elipse)
            {
                promedio=num_pixel_negro/area_elipse;
                printf("\n Promedio= %f\n",promedio);
            }
            else
            {
                promedio=area_elipse/num_pixel_negro;
                printf("\n Promedio= %f\n",promedio);
            }
            num_fotos1--;
            num_fotos2--;

            if(promedio>1.16)
            {
                printf("\n Grano partido\n");
                num_granos_partidos++;
                //Mandar mensaje al hilo de Arduino
                strcpy(szBuffer_arduino,"partido");
                BOOL bResult_arduino = WriteFile(
                                           hPipe_arduino,                // handle to pipe
                                           szBuffer_arduino,             // buffer to write from
                                           strlen(szBuffer_arduino)+1,   // number of bytes to write, include the NULL
                                           &cbBytes,             // number of bytes written
                                           NULL);

                //Mandar mensaje al hilo de analisis
                strcpy(szBuffer_analisis,"no cuenta");
                BOOL bResult_analisis = WriteFile(
                                            hPipe_analisis,       // handle to pipe
                                            szBuffer_analisis,             // buffer to write from
                                            strlen(szBuffer_analisis)+1,   // number of bytes to write, include the NULL
                                            &cbBytes,             // number of bytes written
                                            NULL);                // not overlapped I/O
            }

            else
            {
                printf("\n Grano sin partir\n");

                ///Comprobar que el grano tiene las medidas dentro de un rango establecido
                if(ancho<ancho_min||largo<largo_min)
                {
                    printf("\n Grano no valido.Grano fuera de medidas\n");
                    num_granos_tara++;
                    //Mandar mensaje al hilo de Arduino
                    strcpy(szBuffer_arduino,"tara");
                    BOOL bResult_arduino = WriteFile(
                                               hPipe_arduino,                // handle to pipe
                                               szBuffer_arduino,             // buffer to write from
                                               strlen(szBuffer_arduino)+1,   // number of bytes to write, include the NULL
                                               &cbBytes,             // number of bytes written
                                               NULL);
                    //Mandar mensaje al hilo de analisis
                    strcpy(szBuffer_analisis,"cuenta");
                    BOOL bResult_analisis = WriteFile(
                                                hPipe_analisis,       // handle to pipe
                                                szBuffer_analisis,             // buffer to write from
                                                strlen(szBuffer_analisis)+1,   // number of bytes to write, include the NULL
                                                &cbBytes,             // number of bytes written
                                                NULL);                // not overlapped I/O
                }

                else
                {
                    printf("\n Grano%d valido.El ancho es %d y el largo es %d \n",i+1,ancho,largo);
                    num_granos_buenos++;
                    //Mandar mensaje al hilo de Arduino
                    strcpy(szBuffer_arduino,"bueno");
                    BOOL bResult_arduino = WriteFile(
                                               hPipe_arduino,                // handle to pipe
                                               szBuffer_arduino,             // buffer to write from
                                               strlen(szBuffer_arduino)+1,   // number of bytes to write, include the NULL
                                               &cbBytes,             // number of bytes written
                                               NULL);
                    //Mandar mensaje al hilo de analisis
                    strcpy(szBuffer_analisis,"cuenta");
                    BOOL bResult_analisis = WriteFile(
                                                hPipe_analisis,       // handle to pipe
                                                szBuffer_analisis,             // buffer to write from
                                                strlen(szBuffer_analisis)+1,   // number of bytes to write, include the NULL
                                                &cbBytes,             // number of bytes written
                                                NULL);                // not overlapped I/O
                }
            }
            L_total=L_total+L;
            a_total=a_total+a;
            b_total=b_total+b;
            vector_anchos[i]=ancho;
            vector_largos[i]=largo;
            i++;
            if((num_granos_buenos+num_granos_tara)==num_granos)
            {
                printf("Fin analisis\n");
                //Mandar mensaje al hilo de Arduino
                strcpy(szBuffer_arduino,"end");
                BOOL bResult_arduino = WriteFile(
                                           hPipe_arduino,                // handle to pipe
                                           szBuffer_arduino,             // buffer to write from
                                           strlen(szBuffer_arduino)+1,   // number of bytes to write, include the NULL
                                           &cbBytes,             // number of bytes written
                                           NULL);
                CloseHandle(hPipe_arduino);
                break;
            }

        }
        ///Cada 0.5 segundos tomamos una foto nueva
        key_pulsada='f';
        Sleep(temporizador);

    }

    for(i=0; i<num_granos; i++)
    {
        ancho_granos=ancho_granos+vector_anchos[i];
        largo_granos=largo_granos+vector_largos[i];
    }

    int porcentaje_buenos,porcentaje_partidos,porcentaje_tara;
    char porcentaje_buenos_c[5],porcentaje_partidos_c[5],porcentaje_tara_c[5];

    porcentaje_buenos=(num_granos_buenos/num_granos)*100;
    porcentaje_partidos=(num_granos_partidos/num_granos)*100;
    porcentaje_tara=(num_granos_tara/num_granos)*100;

    printf("** ESTADISTICAS DEL ANALISIS **\n");
    printf("\n El numero de granos buenos es :%d (%d%%)\n",num_granos_buenos,porcentaje_buenos);
    printf("\n El numero de granos partidos es:%d (%d%%)\n",num_granos_partidos,porcentaje_partidos);
    printf("\n El numero de granos con tara en las medidas es:%d (%d%%)\n",num_granos_tara,porcentaje_tara);
    printf("\n El tamao medio de los granos es ancho %d y largo %d\n",ancho_granos/num_granos,largo_granos/num_granos);
    printf("\n Los valores de tonalidad medios son L:%f a:%f b:%f\n",L_total/num_granos,a_total/num_granos,b_total/num_granos);

    ///Escribimos en el fichero los datos obtenidos del grano
    fichero = fopen(valores->nom_fichero, "a");
    if(!fichero)
    {
        printf("El fichero no se puede abrir\n");
    }
    fprintf(fichero,"El numero total de granos analizados es :");
    fprintf(fichero,itoa(num_granos,num_granos_c,10));
    fprintf(fichero,"\n");
    fprintf(fichero,"El numero de granos buenos es :");
    fprintf(fichero,itoa(num_granos_buenos,num_granos_buenos_c,10));
    fprintf(fichero," (");
    fprintf(fichero,itoa(porcentaje_buenos,porcentaje_buenos_c,10));
    fprintf(fichero,"%%)");
    fprintf(fichero,"\n");
    fprintf(fichero,"El numero de granos partidos es :");
    fprintf(fichero,itoa(num_granos_partidos,num_granos_partidos_c,10));
    fprintf(fichero," (");
    fprintf(fichero,itoa(porcentaje_partidos,porcentaje_partidos_c,10));
    fprintf(fichero,"%%)");
    fprintf(fichero,"\n");
    fprintf(fichero,"El numero de granos con tara es :");
    fprintf(fichero,itoa(num_granos_tara,num_granos_tara_c,10));
    fprintf(fichero," (");
    fprintf(fichero,itoa(porcentaje_tara,porcentaje_tara_c,10));
    fprintf(fichero,"%%)");
    fprintf(fichero,"\n");
    fprintf(fichero,"El ancho medio de los granos es :");
    fprintf(fichero,itoa(ancho_granos/num_granos,ancho_c,10));
    fprintf(fichero,"\n");
    fprintf(fichero,"El largo medio de los granos es :");
    fprintf(fichero,itoa(largo_granos/num_granos,largo_c,10));
    fprintf(fichero,"\n");
    fprintf(fichero,"Los valores de tonalidad medios (Lab) son :");
    fprintf(fichero,itoa(L_total/num_granos,L_total_c,10));
    fprintf(fichero," ");
    fprintf(fichero,itoa(a_total/num_granos,a_total_c,10));
    fprintf(fichero," ");
    fprintf(fichero,itoa(b_total/num_granos,b_total_c,10));
    fprintf(fichero,"\n");
    fprintf(fichero,"\n");
    fclose(fichero);

    cvWaitKey(0);
    cvReleaseCapture(&captura);
    cvDestroyAllWindows();

    return 0;
}
