#include "analisis_grano.h"

DWORD WINAPI hilo_comunicacion( void* lpParam )
{
    Serial* Arduino;
    int x;
    char serialPort[11];
    char szBuffer_arduino[BUFFER_SIZE];
    DWORD cbBytes;

    /* Bucle para comprobar en que puerto serie esta conectado el Arduino */
    printf("Comprobando conexion con Arduino\n");
    for(x = 0; x < 11; x++)
    {
        sprintf(serialPort, "COM%d", x);
        Arduino = new Serial(serialPort);
        if (Arduino->IsConnected()==true)
        {
            printf("Arduino conectado\n");
            break;
        }
    }

    /* Creamos pipe para comunicacion IPC*/
    HANDLE hPipe_arduino;

    hPipe_arduino = CreateNamedPipe(
                        g_szPipeNameArduino,             // pipe name
                        PIPE_ACCESS_DUPLEX,       // read/write access
                        PIPE_TYPE_MESSAGE |       // message type pipe
                        PIPE_READMODE_MESSAGE |   // message-read mode
                        PIPE_WAIT,                // blocking mode
                        PIPE_UNLIMITED_INSTANCES, // max. instances
                        BUFFER_SIZE,              // output buffer size
                        BUFFER_SIZE,              // input buffer size
                        NMPWAIT_USE_DEFAULT_WAIT, // client time-out
                        NULL);                    // default security attribute

    if (INVALID_HANDLE_VALUE == hPipe_arduino)
    {
        printf("\nError occurred while "
               "creating the Arduino pipe: %ld\n", GetLastError());
        //return 1;  //Error
    }
    else
    {
        printf("\nCreateNamedPipeArduino() was successful.\n");
    }

    printf("\nWaiting for client connection...\n");

    /* Bucle de servicio */
    while( Arduino->IsConnected() )
    {
        //Leemos el mensaje del cliente
        BOOL bResult_arduino = ReadFile(
                                   hPipe_arduino,                // handle to pipe
                                   szBuffer_arduino,             // buffer to receive data
                                   sizeof(szBuffer_arduino),     // size of buffer
                                   &cbBytes,             // number of bytes read
                                   NULL);                // not overlapped I/O

        printf("\nClient sent the following message: %s\n", szBuffer_arduino);

        Arduino->WriteData(szBuffer_arduino,sizeof(szBuffer_arduino)-1);

        if(strcmp(szBuffer_arduino,"end")==0)
        {
            Arduino->WriteData(szBuffer_arduino,sizeof(szBuffer_arduino)-1);
            break;
        }
    }
    CloseHandle(hPipe_arduino);
    Arduino->connected=false;
    CloseHandle(Arduino->hSerial);
    printf("Arduino desconectado\n");

    return 0;
}
