#include "analisis_grano.h"

float convertir_rgb_lab(float R,float G, float B,float *lum,float *a,float *b )
{
    float X,Y,Z,Fx,Fy,Fz;

    ///Convertir valores RGB a LAB
    ///Primero convertir de RGB a XYZ

    //Normalizar valores RGB
    R=R/255;
    G=G/255;
    B=B/255;

    if(R>0.04045)
    {
        R=pow(((R+0.055)/1.055),2.4);
    }
    else
        R=R/12.92;

    if(G>0.04045)
    {
        G=pow(((G+0.055)/1.055),2.4);
    }
    else
        G=G/12.92;

    if(B>0.04045)
    {
        B=pow(((B+0.055)/1.055),2.4);
    }
    else
        B=B/12.92;

    R=R*100;
    G=G*100;
    B=B*100;

    X=(0.4124*R)+(0.3576*G)+(0.1804*B);
    Y=(0.2127*R)+(0.7152*G)+(0.0722*B);
    Z=(0.0193*R)+(0.1192*G)+(0.9502*B);

    X=X/95.047;
    Y=Y/100;
    Z=Z/108.883;

    ///Segundo convertir de XYZ a LAB

    if (X<0.008856)
    {
        Fx=(7.787*X)+(16/116);

    }
    else
        Fx=pow(X,0.33);

    if (Y<0.008856)
    {
        Fy=(7.787*Y)+(16/116);
        *lum=903.3*Y;
    }
    else
    {
        Fy=pow(Y,0.33);
        *lum=(116*Fy)-16;
    }

    if (Z<0.008856)
    {
        Fz=(7.787*Z)+(16/116);
    }
    else
        Fz=pow(Z,0.33);


    *a=500*(Fx-Fy);
    *b=200*(Fy-Fz);

    printf("\n L:%f A:%f B:%f\n",*lum,*a,*b);

    return 0;

}
