#include "analisis_grano.h"

void crea_pipe_cliente(void)
{
    HANDLE hPipe;

    //Connect to the server pipe using CreateFile()
    hPipe = CreateFile(
                g_szPipeName,   // pipe name
                GENERIC_READ |  // read and write access
                GENERIC_WRITE,
                0,              // no sharing
                NULL,           // default security attributes
                OPEN_EXISTING,  // opens existing pipe
                0,              // default attributes
                NULL);          // no template file

    if (INVALID_HANDLE_VALUE == hPipe)
    {
        printf("\nError occurred while connecting"
               " to the server: %ld", GetLastError());
        //One might want to check whether the server pipe is busy
        //This sample will error out if the server pipe is busy
        //Read on ERROR_PIPE_BUSY and WaitNamedPipe() for that
        //return 1;  //Error
    }
    else
    {
        printf("\nCreateFile() was successful.");
    }

}

void crea_pipe_servidor(void)
{
    HANDLE hPipe;

    hPipe = CreateNamedPipe(
                g_szPipeName,             // pipe name
                PIPE_ACCESS_DUPLEX,       // read/write access
                PIPE_TYPE_MESSAGE |       // message type pipe
                PIPE_READMODE_MESSAGE |   // message-read mode
                PIPE_WAIT,                // blocking mode
                PIPE_UNLIMITED_INSTANCES, // max. instances
                BUFFER_SIZE,              // output buffer size
                BUFFER_SIZE,              // input buffer size
                NMPWAIT_USE_DEFAULT_WAIT, // client time-out
                NULL);                    // default security attribute

    if (INVALID_HANDLE_VALUE == hPipe)
    {
        printf("\nError occurred while "
               "creating the pipe: %ld", GetLastError());
        //return 1;  //Error
    }
    else
    {
        printf("\nCreateNamedPipe() was successful.");
    }

    printf("\nWaiting for client connection...");

}
