#include "analisis_grano.h"

const gchar *referencia=0, *L_ref=0, *a_ref=0, *b_ref=0;
char nom_fichero[24];
float porcentaje;
static gboolean continue_timer=FALSE; /*Determina si el temporizador continua o no */
static gboolean start_timer=FALSE; /*Determina si el temporizador ha comenzado */

HANDLE hPipe;
HANDLE hPipe_analisis;

GdkPixbuf *create_pixbuf(const gchar * filename)
{
    GdkPixbuf *pixbuf;
    GError *error = NULL;
    pixbuf = gdk_pixbuf_new_from_file(filename, &error);
    if(!pixbuf)
    {
        fprintf(stderr, "%s\n", error->message);
        g_error_free(error);
    }

    return pixbuf;
}

static gboolean image1_update(gpointer data)
{
    GtkImage *image=(GtkImage*) data;
    gtk_image_set_from_file(image,"frame.png");
    if (porcentaje==1)
    {
        return FALSE;
    }
    return continue_timer;

}

static gboolean image2_update(gpointer data)
{
    GtkImage *image=(GtkImage*) data;
    gtk_image_set_from_file(image,"contorno.png");
    if (porcentaje==1)
    {
        return FALSE;
    }
    return continue_timer;
}

static gboolean image3_update(gpointer data)
{
    GtkImage *image=(GtkImage*) data;
    gtk_image_set_from_file(image,"byn.png");
    if (porcentaje==1)
    {
        return FALSE;
    }

    return continue_timer;
}

static gboolean inc_barra_progreso(gpointer data)
{
    float ng=num_granos;
    char szBuffer[BUFFER_SIZE];
    DWORD cbBytes;

    BOOL bResult = ReadFile(
                       hPipe_analisis,       // handle to pipe
                       szBuffer,             // buffer to receive data
                       sizeof(szBuffer),     // size of buffer
                       &cbBytes,             // number of bytes read
                       NULL);                // not overlapped I/O

    if(strcmp(szBuffer,"cuenta")==0)
    {
        printf("Grano contado\n");
        porcentaje+=1/ng;
        printf("Porcentaje:%f\n",porcentaje);
    }
    else
    {
        printf("Grano no contado\n");
        printf("Porcentaje:%f\n",porcentaje);
    }

    gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(data),porcentaje);
    char c[3];
    sprintf(c, "%d%%", static_cast<int>(porcentaje*100));
    gtk_progress_bar_set_text(GTK_PROGRESS_BAR(data), c);

    if(porcentaje>=1)
    {
        CloseHandle(hPipe_analisis);
        return FALSE;
    }

    return continue_timer;
}

void fin_analisis (gpointer data)
{
    GtkWidget *dialog = NULL;

    dialog = gtk_message_dialog_new(0,GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_QUESTION,GTK_BUTTONS_YES_NO,"Analisis terminado con exito");
    gtk_message_dialog_format_secondary_text(GTK_MESSAGE_DIALOG(dialog),"Desea ver el informe de los resultados del analisis?");
    gtk_window_set_title(GTK_WINDOW(dialog), "Fin del analisis");
    gint result = gtk_dialog_run (GTK_DIALOG (dialog));
    switch (result)
    {
    case GTK_RESPONSE_YES:
        gtk_widget_destroy(dialog);
        system(nom_fichero);
        break;
    case GTK_RESPONSE_NO:
        gtk_widget_destroy(dialog);
        break;
    }
}

static void intro_datos( GtkWidget *widget,gpointer *entry )
{
    referencia = gtk_entry_get_text(GTK_ENTRY (entry[0]));
    L_ref = gtk_entry_get_text(GTK_ENTRY (entry[1]));
    a_ref = gtk_entry_get_text(GTK_ENTRY (entry[2]));
    b_ref = gtk_entry_get_text(GTK_ENTRY (entry[3]));

}

static void mostrar_fichero(GtkWidget *widget, gpointer *data)
{
    const gchar *text;
    char *nom_fichero=NULL;

    text=gtk_entry_get_text(GTK_ENTRY(data));
    nom_fichero=(gchar*) text;
    strcat(nom_fichero,".txt");
    system(nom_fichero);

}

static void quit (GtkWidget *wid, GtkWidget *win)
{
    GtkWidget *dialog = NULL;

    dialog = gtk_message_dialog_new(GTK_WINDOW(win),GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_QUESTION,GTK_BUTTONS_YES_NO,"Estas seguro que quieres salir?");
    gtk_window_set_title(GTK_WINDOW(dialog), "Salir del programa");
    gint result = gtk_dialog_run (GTK_DIALOG (dialog));
    switch (result)
    {
    case GTK_RESPONSE_YES:
        gtk_widget_destroy(win);
        break;
    case GTK_RESPONSE_NO:
        gtk_widget_destroy(dialog);
        break;
    }

}

static void consultar_analisis (GtkWidget *wid, GtkWidget *win)
{
    GtkWidget *window = NULL;
    GtkWidget *button = NULL;
    GtkWidget *fixed;
    GtkWidget *label;
    GtkWidget *entry = NULL;

    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
    gtk_window_set_title (GTK_WINDOW (window), "Consultar analisis");
    gtk_container_set_border_width(GTK_CONTAINER(window), 10);
    gtk_window_set_default_size(GTK_WINDOW(window), 600, 400);

    fixed = gtk_fixed_new();
    gtk_container_add(GTK_CONTAINER(window), fixed);

    button = gtk_button_new_with_label ("Cancelar");
    gtk_fixed_put(GTK_FIXED(fixed), button, 240, 250);
    gtk_widget_set_size_request(button, 120, 40);
    g_signal_connect_swapped( G_OBJECT( button ), "clicked",G_CALLBACK( gtk_widget_destroy ), window );

    label=gtk_label_new("Fecha de realizacion del analisis (DD-MM-AA)");
    gtk_fixed_put(GTK_FIXED(fixed), label, 150, 80);
    gtk_widget_set_size_request(label, 300, 20);

    entry = gtk_entry_new();
    gtk_fixed_put(GTK_FIXED(fixed), entry, 200, 100);
    gtk_widget_set_size_request(entry, 200, 20);
    g_signal_connect(entry, "activate", G_CALLBACK(mostrar_fichero), entry);

    button = gtk_button_new_with_label ("Consultar analisis");
    gtk_fixed_put(GTK_FIXED(fixed), button, 240, 300);
    gtk_widget_set_size_request(button, 120, 40);
    g_signal_connect(button, "clicked", G_CALLBACK (mostrar_fichero), entry);

    gtk_widget_show_all (window);
}

static void comenzar_analisis (GtkWidget *wid, gpointer *entry)
{
    GtkWidget *window = NULL;
    GtkWidget *fixed;
    GtkWidget *image1,*image2,*image3;
    GtkWidget *progressbar;
    GtkWidget *label;
    GtkWidget *button;

    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
    gtk_window_set_title (GTK_WINDOW (window), "Analisis en curso");
    gtk_container_set_border_width(GTK_CONTAINER(window), 5);
    gtk_window_set_default_size(GTK_WINDOW(window), 1140, 600);

    fixed = gtk_fixed_new();
    gtk_container_add(GTK_CONTAINER(window), fixed);

    image1 = gtk_image_new_from_file("lupa.jpg");
    gtk_fixed_put(GTK_FIXED(fixed), image1, 10, 10);
    gtk_widget_set_size_request(image1, 340, 340);

    image2 = gtk_image_new_from_file("lupa.jpg");
    gtk_fixed_put(GTK_FIXED(fixed), image2, 400, 10);
    gtk_widget_set_size_request(image2, 340, 340);

    image3 = gtk_image_new_from_file("lupa.jpg");
    gtk_fixed_put(GTK_FIXED(fixed), image3, 790, 10);
    gtk_widget_set_size_request(image3, 340, 340);

    label=gtk_label_new("Progreso del analisis");
    gtk_fixed_put(GTK_FIXED(fixed), label, 275, 460);
    gtk_widget_set_size_request(label, 300, 40);

    progressbar = gtk_progress_bar_new();
    gtk_progress_bar_set_orientation( GTK_PROGRESS_BAR (progressbar), GTK_PROGRESS_LEFT_TO_RIGHT );
    gtk_fixed_put(GTK_FIXED(fixed), progressbar, 225, 500);
    gtk_widget_set_size_request(progressbar, 400, 40);

    button = gtk_button_new_with_label ("Salir");
    gtk_fixed_put(GTK_FIXED(fixed), button, 700, 500);
    gtk_widget_set_size_request(button, 120, 40);
    g_signal_connect_swapped( G_OBJECT( button ), "clicked",G_CALLBACK( gtk_widget_destroy ), window );

    gtk_widget_show_all (window);

    ///Convertimos en variables float los campos leidos de los widgets entry
    float L_ref_n, a_ref_n, b_ref_n;

    L_ref_n=atof((gchar*) L_ref);
    a_ref_n=atof((gchar*) a_ref);
    b_ref_n=atof((gchar*) b_ref);

    ///Creamos el fichero para guardar los resultados de los analisis
    struct tm *tm;
    time_t t;
    FILE *fichero;

    char fechayhora[18],fecha[18];

    t=time(NULL);
    tm=localtime(&t);
    strftime(fechayhora,18,"%d/%m/%y %H:%M:%S",tm);
    strftime(fecha,18,"%d-%m-%y",tm);
    strcat(fecha,".txt");
    strcpy(nom_fichero,fecha);

    fichero = fopen(nom_fichero, "a");
    fprintf(fichero,"ANALISIS REALIZADO CON FECHA Y HORA \n");
    fprintf (fichero,fechayhora);
    fprintf(fichero,"\n");
    fprintf(fichero,"REFERENCIA DEL LOTE:");
    fprintf (fichero,referencia);
    fprintf(fichero,"\n");
    fclose(fichero);

    ///Comenzamos el analisis

    HANDLE Handle_Of_Thread_1 = 0;
    static DATOS datos;

    datos.a_ref_n=a_ref_n;
    datos.b_ref_n=b_ref_n;
    datos.L_ref_n=L_ref_n;
    strcpy(datos.nom_fichero,nom_fichero);

    // Creamos un hilo donde se ejecutara el codigo del analisis
    Handle_Of_Thread_1 = CreateThread( NULL, 0, hilo_analisis_granos, &datos, 0, NULL);

    ///Refrescamos las imagenes para tener siempre las ultimas imagenes generadas y Actualizamos el valor de la barra de progreso
    porcentaje=0;
    g_timeout_add(temporizador, image1_update, image1);
    g_timeout_add(temporizador+1, image2_update, image2);
    g_timeout_add(temporizador+2, image3_update, image3);
    g_timeout_add_full(G_PRIORITY_DEFAULT,temporizador+3, inc_barra_progreso, progressbar,fin_analisis);
    continue_timer=TRUE;
    start_timer=TRUE;
}

static void nuevo_analisis (GtkWidget *widget, GtkWidget *win)
{
    GtkWidget *window = NULL;
    GtkWidget *button = NULL;
    GtkWidget *fixed;
    GtkWidget *label;

    static GtkWidget *entry[4]= {NULL,NULL,NULL,NULL};

    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
    gtk_window_set_title (GTK_WINDOW (window), "Nuevo analisis");
    gtk_container_set_border_width(GTK_CONTAINER(window), 10);
    gtk_window_set_default_size(GTK_WINDOW(window), 600, 400);

    fixed = gtk_fixed_new();
    gtk_container_add(GTK_CONTAINER(window), fixed);

    button = gtk_button_new_with_label ("Cancelar");
    gtk_fixed_put(GTK_FIXED(fixed), button, 450, 250);
    gtk_widget_set_size_request(button, 120, 40);
    g_signal_connect_swapped( G_OBJECT( button ), "clicked",G_CALLBACK( gtk_widget_destroy ), window );

    label=gtk_label_new("Referencia del lote");
    gtk_fixed_put(GTK_FIXED(fixed), label, 10, 40);
    gtk_widget_set_size_request(label, 200, 20);

    entry[0] = gtk_entry_new();
    gtk_fixed_put(GTK_FIXED(fixed), entry[0], 10, 60);
    gtk_widget_set_size_request(entry[0], 200, 20);

    label=gtk_label_new("Parametro L");
    gtk_fixed_put(GTK_FIXED(fixed), label, 10, 90);
    gtk_widget_set_size_request(label, 200, 20);

    entry[1] = gtk_entry_new();
    gtk_fixed_put(GTK_FIXED(fixed), entry[1], 10, 110);
    gtk_widget_set_size_request(entry[1], 200, 20);

    label=gtk_label_new("Parametro a");
    gtk_fixed_put(GTK_FIXED(fixed), label, 10, 140);
    gtk_widget_set_size_request(label, 200, 20);

    entry[2] = gtk_entry_new();
    gtk_fixed_put(GTK_FIXED(fixed), entry[2], 10, 160);
    gtk_widget_set_size_request(entry[2], 200, 20);

    label=gtk_label_new("Parametro b");
    gtk_fixed_put(GTK_FIXED(fixed), label, 10, 190);
    gtk_widget_set_size_request(label, 200, 20);

    entry[3] = gtk_entry_new();
    gtk_fixed_put(GTK_FIXED(fixed), entry[3], 10, 210);
    gtk_widget_set_size_request(entry[3], 200, 20);
    g_signal_connect(entry[3], "activate", G_CALLBACK(intro_datos), entry);
    g_signal_connect(entry[3], "activate", G_CALLBACK(comenzar_analisis), entry);

    button = gtk_button_new_with_label ("Comenzar analisis");
    gtk_fixed_put(GTK_FIXED(fixed), button, 450, 300);
    gtk_widget_set_size_request(button, 120, 40);
    g_signal_connect(G_OBJECT (button), "clicked", G_CALLBACK (intro_datos), entry);
    g_signal_connect(G_OBJECT (button), "clicked", G_CALLBACK (comenzar_analisis), entry);

    gtk_widget_show_all (window);

    /* Creamos el hilo de comunicacion con Arduino */
    HANDLE Handle_Of_Thread_2 = 0;
    Handle_Of_Thread_2 = CreateThread( NULL, 0, hilo_comunicacion, 0, 0, NULL);
    if (Handle_Of_Thread_2 == NULL)
    {
        printf("CreateThread failed, GLE=%ld\n", GetLastError());
        //return -1;
    }
    else CloseHandle(Handle_Of_Thread_2);

    /* Creamos la comunicacion con el hilo de analisis*/
    hPipe_analisis = CreateNamedPipe(
                         g_szPipeNameAnalisis,             // pipe name
                         PIPE_ACCESS_DUPLEX,       // read/write access
                         PIPE_TYPE_MESSAGE |       // message type pipe
                         PIPE_READMODE_MESSAGE |   // message-read mode
                         PIPE_WAIT,                // blocking mode
                         PIPE_UNLIMITED_INSTANCES, // max. instances
                         BUFFER_SIZE,              // output buffer size
                         BUFFER_SIZE,              // input buffer size
                         NMPWAIT_USE_DEFAULT_WAIT, // client time-out
                         NULL);                    // default security attribute

    if (INVALID_HANDLE_VALUE == hPipe_analisis)
    {
        printf("\nError occurred while "
               "creating the Analisis pipe: %ld\n", GetLastError());
        //return 1;  //Error
    }
    else
    {
        printf("\nCreateNamedPipeAnalisis() was successful.\n");
    }
}

int main (int argc, char *argv[])
{
    GtkWidget *button = NULL;
    GtkWidget *win = NULL;
    GtkWidget *fixed;

    /* Inicializamos GTK+ */
    g_log_set_handler ("Gtk", G_LOG_LEVEL_WARNING, (GLogFunc) gtk_false, NULL);
    gtk_init (&argc, &argv);
    g_log_set_handler ("Gtk", G_LOG_LEVEL_WARNING, g_log_default_handler, NULL);

    /* Creamos la ventana principal */
    win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_container_set_border_width (GTK_CONTAINER (win), 10);
    gtk_window_set_default_size(GTK_WINDOW(win), 600, 400);
    gtk_window_set_title (GTK_WINDOW (win), "Analisis granos");
    gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_CENTER);
    gtk_window_set_icon(GTK_WINDOW(win), create_pixbuf("logo.jpg"));
    gtk_widget_realize (win);
    g_signal_connect (win, "destroy", gtk_main_quit, NULL);

    fixed = gtk_fixed_new();
    gtk_container_add(GTK_CONTAINER(win), fixed);

    button = gtk_button_new_with_label ("Nuevo analisis");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (nuevo_analisis), (gpointer) win);
    gtk_fixed_put(GTK_FIXED(fixed), button, 180, 50);
    gtk_widget_set_size_request(button, 240, 80);

    button = gtk_button_new_with_label ("Consultar analisis");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (consultar_analisis), (gpointer) win);
    gtk_fixed_put(GTK_FIXED(fixed), button, 180, 150);
    gtk_widget_set_size_request(button, 240, 80);

    button = gtk_button_new_with_label ("Salir");
    g_signal_connect (button, "clicked", G_CALLBACK (quit), (gpointer) win);
    gtk_fixed_put(GTK_FIXED(fixed), button, 180, 250);
    gtk_widget_set_size_request(button, 240, 80);

    /* Bucle de trabajo principal */
    gtk_widget_show_all (win);
    gtk_main ();


    return 0;


}
